/*----------------------------------------------------------------------
    Miscellaneous functions
	Created  by H.TSUKATA       1995
        Modified by H.Goto    Sept. 1997
----------------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1995-1997  Hitoshi TSUKATA

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hitoshi TSUKATA, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "zenza.h"
#include "nng.h"

void fo_exit( char *fn){
  fprintf(stderr,"File error , Can't Open %s\n", fn);
  exit(1);
}

FILE *fo( char *fn, char *mode)
{
  FILE	*fptmp;
  
  if( fn==NULL) fo_exit( fn);
  if( strlen( fn)<1){
	// if filename is omitted ...
	if( strchr( mode, 'w'))	return( stdout);
	else	return( stdin);
  }  else{
	if( (fptmp=fopen( fn, mode)) ==NULL){
	  fo_exit( fn);
	} else{
	  fclose( fptmp);
	  return( fopen( fn, mode));
	}
  }
  return NULL;
}

double moment(double *data, int n)
{
   /*
    *	ǡ data[i]  n⡼Ȥ ǡνü,MAX_DBL
    *
    *		Ĥޤ  {data(i)^n * p(i)}
    *		        i
    *		p(i)ϳΩ̩ٴؿ.
    */

   double	sum=0.0;
   int		i;

   for( i=0 ; data[i]<DBL_MAX ; i++){
	 sum += pow( data[i], (double) n);
   }
   return( sum/(double) i);
}


int mm2dot( double x){
  return ( (int)(x*200/25.4));
}

int pt2dot( double x){
  return ( (int)(x*200/(25.4/.35)));
}
