/*----------------------------------------------------------------------
    Text Line manipulation
	Created  by H.TSUKATA  1995
        Modified by H.Goto     Sept. 1997
----------------------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1995-1997  Hitoshi TSUKATA

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hitoshi TSUKATA, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#ifndef _LINE_H_
#define _LINE_H_

#include "node.h"

class Rectangle{
public:
  short	x;
  short	y;
  short	w;
  short	h;
  
  Rectangle( short _x=0, short _y=0, short _w=0, short _h=0){	x=_x; y=_y; w=_w; h=_h;  }
  Rectangle( Rectangle & src){	x=src.x; y=src.y; w=src.w; h=src.h;  } 
  Rectangle & operator =( const Rectangle & src){
	if( this == &src) return *this;
	x = src.x;	y = src.y;	w = src.w;	h = src.h;
	return *this;
  }
  void empty(void){	x = 0; y = 0; w = 0; h = 0;  }	
  void setdata( short _x, short _y, short _w, short _h)	{	
	x=_x; y=_y; w=_w; h=_h; }	  

  int chk_marker( void);
  void set_marker( short);
  void byte_ch( void);

};


class STRING : public NODE<STRING*>{
public:
  int	nd_visit_check( STRING *p){	
	if( p!=NULL) return 1; else return(0); 
  }

  TREE_INDEX	index;
  int		x;	
  int		y;
  LINEHEIGHT 	h;
  int		w;
  double	cx;	/* (cx,cy);νſɸ  */
  double	cy;
  LINESLOPE	slope;	// DEG.
  int		label;
  double	gap;
  STRING	*nearestnode[2];
  double	nearestdist[2];
  int		vst;
  RGN		*tree;		
  Rectangle	*box;		
  int		box_num;	//ޡ*ޤʤ* Ŀ
  List<class STRING *>	adj;	// դˤܴطˤ
  int		*run;
  List<int> c_cand[2]; // FS 0;ü 1;򵯤;
  List<int>	*cutpoints;	// ǽǺɸ ( **кɸ**)
  
  void calc_data( void);
  int readdata( FILE *);
  void STRING::writedata( FILE *);

  STRING (void){
	adj.clear();
	label = EMPTY_LABEL;
	vst = 0;
	w = 0;
	h = 0;
  }
  STRING ( STRING &src){	(*this) = src;  }
  virtual ~STRING(void){}
  int chk_marker( void){	return( h<=0 && w<=0);  }
  void set_marker( void){	h=0;	w=0;  }

  void makeccand(void);
};


#ifdef __cplusplus
extern "C" {
#endif

  void makens(STRING *);
  void makenss(STRING *);
  double linedistance(STRING *, STRING *);
  Rectangle * read_cr( FILE *fp, int *cnt);
  int compare( STRING *sp0, STRING *sp1);
  int rect_overlap( Rectangle *, Rectangle *);
  int str_overlap( STRING *, STRING *);
  
#ifdef __cplusplus
}
#endif


#endif /* _LINE_H_*/
