/*
 *		nng.h     includefile for libnng.a
 *	
 */

/*--------------------------------------------------------------------
  Copyright (C) 1995-1997  Hitoshi TSUKATA

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hitoshi TSUKATA, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#ifndef _NNG_H_
#define _NNG_H_

#include <stdio.h>
#include <iostream.h>
#include <DLList.h>				//	/usr/local/lib/g++-include/DLList.h

template <class T>
class List : public DLList<T> {
public:
  int contain( T const & x){
	/*
	 *	;   x ޤޤƤ xƬΰ
	 *			ޤޤʤ -1
	 */
	List<T>	tmp;
	int	p=0;
	for( tmp=*this ; tmp.empty()==0 ; tmp.del_front(), p++)
	  if( tmp.front() == x)	return( p);
	return(-1);
  }

  void del(    T const &  x){
	List<T> tmp;
	if( contain( x)>-1){
	  for( tmp=*this ; tmp.empty()==0 && tmp.front()!=x ; tmp.del_front());
	  tmp.del_front();
	  for(  ; this->empty()==0 && this->rear()!=x ; this->del_rear());
	  this->del_rear();
	  this->join( tmp);
	}
  }
  void insert_before(   T const & x1, T const &  x){
	// inserts x1 before the x.
	List<T> tmp;
	if( contain( x)>-1){
	  for( tmp=*this; tmp.empty()==0 && tmp.front()!=x; tmp.del_front());
	  for(  ; this->empty()==0 && this->rear()!=x ; this->del_rear());
	  this->del_rear();
	  this->append( x1);
	  this->join( tmp);
	}
  }
  
  
};



template <class T>
class XList : public List<T> {
public:
  void del( T x){	
	List<T>::del(x);	
	delete( x);  
  }
  virtual ~XList(void){
	for( ; empty()==0; del_front()){
	  T	xxx;
	  xxx = front();
	  //	  delete( front()); }
	  delete xxx;
	}
  }
};


template <class T>
class Vector{
public:
  int	*data;
  int	dim;

  Vector( int n=2){
	dim = n;
	data = new T[n];	
	  //data =( T *) calloc( n, sizeof( T));	
	  //	  T Υ󥹥ȥ饯
	  //	Ӥʤ褦ʤ, Ҥ硼԰¤䤱,
	  //	T  int  ΤȤ ǤˤˤϤˡʤ褦ʤ,
	  //	򤨤Ȥ.. (cf. ABC++ pp.155--157)
  }
  virtual ~Vector( void){	delete []data;  }

  double norm(void){
	double	dd;
	int		i;
	for( dd=0.0,i=0; i<dim; i++){
	  dd += data[i]*data[i];
	}	
	return( sqrt( dd));
  }

  Vector<T > & operator =( const Vector<T > & src){
	int     i;
	if( this == &src) return *this;
	if( dim != src.dim)     exit(1);
	for( i=0; i<dim; i++)
	  data[i] = src.data[i];
	return *this;
  }
  
  Vector<T >  & operator +( Vector<T > src){
#if 0
	Vector<T >      p(dim);
	int             i;      
	if( dim != src.dim)     exit(1);
	for( i=0; i<dim ; i++)
	  p.data[i] = data[i]+src.data[i];
	return ( p);
	//      ʤǤ͡
	//      פɤˤưȤ뤱...   
#endif
	int i;      
	if( dim != src.dim)     exit(1);
	for( i=0; i<dim ; i++)
	  data[i] = data[i]+src.data[i];
	return *this;

  }



};  
  
template <class T>
class Matrix{
public:
  T		**data;
  int	width, height;  

  Matrix( int w=0, int h=0){
	int		i;
	width = w;
	height = h;
	data = new T*[w];	
	for( i=0; i<w; i++){
	  data[i] = new T[h];
	  // data[i] = ( T *) calloc( h, sizeof( T));
	  //	  T Υ󥹥ȥ饯
	  //	Ӥʤ褦ʤ, Ҥ硼԰¤䤱,
	  //	T  int  ΤȤ ǤˤˤϤˡʤ褦ʤ,
	  //	򤨤Ȥ.. (cf. ABC++ pp.155--157)

	  //for( j=0; j<h; j++)
	  //		data[i][j]=0;
	  // 
	  //	 
	  //
	}
  }
  virtual ~Matrix( void){
	int	i;
	for( i=0; i<width; i++)	delete [](data[i]);
	delete []data;
  }

  T & datav( Vector<int> & p){
	return ( data[ p.data[0]][ p.data[1]] );
  }

};

	
#ifdef	__cplusplus
extern "C" {
#endif

FILE *fo( char *fn, char *mode);
double moment(double *data, int n);

FILE *fo( char *fn, char *mode);
int mm2dot( double);
int pt2dot( double);

#ifdef	__cplusplus
  }
#endif

#endif /*_NNG_H_*/
