/*------------------------------------------------------
	Library for Document Analysis System
	(Text-line object class)
		Written  by H.Goto, May  1996
		Modified by H.Goto, Feb. 1997
		E-Mail: hgot@ecip.tohoku.ac.jp
------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1996-1997  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/


#ifndef	TLobj_h
#define	TLobj_h


#define		TLSTAT_VOID		0
#define		TLSTAT_ACTIVE		0x0100
#define		TLSTAT_MODIFIED		0x1000

#define		TLGSTAT_VOID		0
#define		TLGSTAT_ACTIVE		0x0100
#define		TLGSTAT_MODIFIED	0x1000


typedef struct {
	short	x,y,w,h;
} TLrect;


class TLOBJ {
    private:
	int		maxrects;
	int		realloc(int rects);
    protected:
    public:
	int		stat;		/* required variables */
	int		rects;
	TLrect		*rectlist;

	int		addrects(int rects,TLrect *rect);
	int		deleteallrects();
	int		sortrect(int align);

	int		id;		/* optional variables */
	int		attr;
	int		length;
	int		height;
	double		avheight;

			TLOBJ();
	virtual		~TLOBJ();
};




class TLGroup {
    private:
	int		maxlines;
	int		realloc(int lines);
    protected:
    public:
	int		stat;		/* required variables */
	int		lines;
	TLOBJ		**tllist;

	int		addline(TLOBJ *tlobj);
	int		removeline(int line);
	int		deletealllines();
	int		removealllines();

	int		id;		/* optional variables */
	int		attr;

	int		numbering(int start);

			TLGroup();
	virtual		~TLGroup();
};


#endif	/* TLobj_h */
