.TH lnextr2 1 "Aug. 1997"
.SH NAME
lnextr2 \- extract text lines from a document image (Ver.2)
.SH SYNOPSIS
.B lnextr2
.BR
[\-options]
.BR
.I in_file

.SH DESCRIPTION
lnextr2 is a SAMPLE implementation of the Linear Segment Linking (LSL)
method which is a kind of text line extraction method. See references
for the detail of the method.
.PP
lnextr2 reads Primitive Rectangles,extracts text lines, and writes
the outline data on the specified output file.
lnextr2 reads the set of Primitive Rectangles from
.I in_file
created by makepr(1) etc.
The file format of 
.I in_file
is d4file(4).

The file format of the output file is tloutline(4).

The character size (height) in the text line to be extracted
is limited to about 4pt to 10pt. lnextr2 dose not extract text lines
with very small or large characters.

lnextr2 can extract only horizontal text lines. The skew angle of text
line is limited to about -7 to +7degs. lnextr2 can handle text lines 
with various skew angles in a same image. lnextr2 can also handle bent 
or wavy text lines.


.SH OPTIONS
.TP
.B \-rjpass N
Set the number of times of iteration for rejection process as N.
The default is 4 times.
.TP
.B \-split
Enable splitting rejected rectangles.
Use this option for document images in which the spacing between text lines 
is extremely narrow.
.TP
.B \-splits N
Set the number of fragments into which a rejected rectangle is split.
The default is 4.
.TP
.B \-o fname
Specify the name of the output file for extracted text lines.
.TP
.B \-rpr fname
Specify the name of the output file for residue-PRs (Primitive Rectangles).
The residue-PRs are the rectangles that do not belong to any text lines.
.TP
.B \-ps fname
Specify the name of the Postscript file for monitoring text lines.
This option is experimental. You may not use this.
.TP
.B \-info 
Enable printing processing information simultaneously.


.SH EXIT STATUS
The following exit values are returned:
.PD 0
.TP 10
.B 0
Successful completion.
.TP
.B > 0
An error occurred.
.PD

.SH BUGS
The source code of this program must be hard to read,
to analyze or to understand :)

.SH SEE ALSO
makepr(1), d4file(4), tloutline(4)

.SH NOTES
The positions of the both ends of text lines are not obtained
correctly due to the character of Primitive Rectangle. Some 
precise post-processings may be required.
See references for the detail.
.PP
Some improvements of the method have been developed since the first
technical article was printed, and have incorporated into this
program.
.PP
This program is just a SAMPLE, so that there may be some limitations or 
reductions.


.SH REFERENCES
"Robust and Fast Text\-line Extraction Using Local Linearity 
of the Text\-line" by Hideaki Goto and Hirotomo Aso,
Trans. IEICE (D\-II), Vol.J78\-D\-II, No.3, pp.465\-473, March 1995.
(In Japanese)

Or its translated version,

"Robust and Fast Text\-line Extraction Using Local Linearity 
of the Text\-line" by Hideaki Goto and Hirotomo Aso,
Systems and Computers in Japan, Vol.26, No.13, pp.21\-31, 1995,
Scripta Technica, Inc.

.SH AUTHOR
Copyright (C) 1994\-1997 Hideaki Goto
.\" Permission to use, copy, modify, and distribute this software and
.\" its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notice and this permission
.\" notice appear in all copies and in supporting documentation, (ii)
.\" the name of the author, Hideaki Goto, may not be used in any
.\" advertising or otherwise to promote the sale, use or other
.\" dealings in this software without prior written authorization
.\" from the author, (iii) this software may not be used for
.\" commercial products without prior written permission from the
.\" author, and (iv) the notice of the modification is specified in
.\" case of that the modified copies of this software are distributed.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
.\" THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
.\" SOFTWARE.

E\-Mail: hgot@ecip.tohoku.ac.jp, hgot@aso.ecei.tohoku.ac.jp
